function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React from 'react';
import cn from 'classnames';
import debounce from 'lodash/debounce';
import Plain from 'slate-plain-serializer';
import { makeValue, SCHEMA } from './utils';
import { Editor } from '@grafana/slate-react';
import { GrafanaThemeType } from './types';
import { ClearPlugin, NewlinePlugin, SelectionShortcutsPlugin, IndentationPlugin, ClipboardPlugin, RunnerPlugin, SuggestionsPlugin } from './slate-plugins';
import { ThemeContext } from './context';
import './styles/queryField.css';
/**
 * Renders an editor field.
 * Pass initial value as initialQuery and listen to changes in props.onValueChanged.
 * This component can only process strings. Internally it uses Slate Value.
 * Implement props.onTypeahead to use suggestions, see PromQueryField.tsx as an example.
 */

export var QueryField = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(QueryField, _React$PureComponent);

  var _super = _createSuper(QueryField);

  function QueryField(props, context) {
    var _this;

    _classCallCheck(this, QueryField);

    _this = _super.call(this, props, context);
    _this.plugins = void 0;
    _this.runOnChangeDebounced = void 0;
    _this.lastExecutedValue = null;
    _this.mounted = false;
    _this.editor = null;

    _this.onChange = function (value, runQuery) {
      var documentChanged = value.document !== _this.state.value.document;
      var prevValue = _this.state.value;

      if (_this.props.onRichValueChange) {
        _this.props.onRichValueChange(value);
      } // Update local state with new value and optionally change value upstream.


      _this.setState({
        value: value
      }, function () {
        // The diff is needed because the actual value of editor have much more metadata (for example text selection)
        // that is not passed upstream so every change of editor value does not mean change of the query text.
        if (documentChanged) {
          var textChanged = Plain.serialize(prevValue) !== Plain.serialize(value);

          if (textChanged && runQuery) {
            _this.runOnChangeAndRunQuery();
          }

          if (textChanged && !runQuery) {
            // Debounce change propagation by default for perf reasons.
            _this.runOnChangeDebounced();
          }
        }
      });
    };

    _this.runOnChange = function () {
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(Plain.serialize(_this.state.value));
      }
    };

    _this.runOnRunQuery = function () {
      var onRunQuery = _this.props.onRunQuery;

      if (onRunQuery) {
        onRunQuery();
        _this.lastExecutedValue = _this.state.value;
      }
    };

    _this.runOnChangeAndRunQuery = function () {
      // onRunQuery executes query from Redux in Explore so it needs to be updated sync in case we want to run
      // the query.
      _this.runOnChange();

      _this.runOnRunQuery();
    };

    _this.handleBlur = function (event, editor, next) {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        onBlur();
      } else {
        // Run query by default on blur
        var previousValue = _this.lastExecutedValue ? Plain.serialize(_this.lastExecutedValue) : null;
        var currentValue = Plain.serialize(editor.value);

        if (previousValue !== currentValue) {
          _this.runOnChangeAndRunQuery();
        }
      }

      return next();
    };

    _this.runOnChangeDebounced = debounce(_this.runOnChange, 500);
    var onTypeahead = props.onTypeahead,
        cleanText = props.cleanText,
        portalOrigin = props.portalOrigin,
        onWillApplySuggestion = props.onWillApplySuggestion; // Base plugins

    _this.plugins = [// SuggestionsPlugin and RunnerPlugin need to be before NewlinePlugin
    // because they override Enter behavior
    SuggestionsPlugin({
      onTypeahead: onTypeahead,
      cleanText: cleanText,
      portalOrigin: portalOrigin,
      onWillApplySuggestion: onWillApplySuggestion
    }), RunnerPlugin({
      handler: _this.runOnChangeAndRunQuery
    }), NewlinePlugin(), ClearPlugin(), SelectionShortcutsPlugin(), IndentationPlugin(), ClipboardPlugin()].concat(_toConsumableArray(props.additionalPlugins || [])).filter(function (p) {
      return p;
    });
    _this.state = {
      suggestions: [],
      typeaheadContext: null,
      typeaheadPrefix: '',
      typeaheadText: '',
      value: makeValue(props.query || '', props.syntax)
    };
    return _this;
  }

  _createClass(QueryField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props = this.props,
          query = _this$props.query,
          syntax = _this$props.syntax,
          syntaxLoaded = _this$props.syntaxLoaded;

      if (!prevProps.syntaxLoaded && syntaxLoaded && this.editor) {
        // Need a bogus edit to re-render the editor after syntax has fully loaded
        var editor = this.editor.insertText(' ').deleteBackward(1);
        this.onChange(editor.value, true);
      }

      var value = this.state.value; // Handle two way binging between local state and outside prop.
      // if query changed from the outside

      if (query !== prevProps.query) {
        // and we have a version that differs
        if (query !== Plain.serialize(value)) {
          this.setState({
            value: makeValue(query || '', syntax)
          });
        }
      }
    }
    /**
     * Update local state, propagate change upstream and optionally run the query afterwards.
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          _this$props2$themeMod = _this$props2.themeMode,
          themeMode = _this$props2$themeMod === void 0 ? GrafanaThemeType.Light : _this$props2$themeMod;
      return /*#__PURE__*/React.createElement(ThemeContext.Provider, {
        value: {
          type: themeMode
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: cn('qf__wrapper', {
          'qf__wrapper-disabled': disabled,
          'qf-light__wrapper': themeMode === GrafanaThemeType.Light,
          'qf-dark__wrapper': themeMode === GrafanaThemeType.Dark
        })
      }, /*#__PURE__*/React.createElement("div", {
        className: "qf",
        "aria-label": "Query field"
      }, /*#__PURE__*/React.createElement(Editor, {
        ref: function ref(editor) {
          return _this2.editor = editor;
        },
        schema: SCHEMA,
        autoCorrect: false,
        readOnly: this.props.disabled,
        onBlur: this.handleBlur,
        onClick: this.props.onClick,
        // onKeyDown={this.onKeyDown}
        onChange: function onChange(change) {
          _this2.onChange(change.value, false);
        },
        placeholder: this.props.placeholder,
        plugins: this.plugins,
        spellCheck: false,
        value: this.state.value
      }))));
    }
  }]);

  return QueryField;
}(React.PureComponent);