function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React, { createRef } from 'react';
import cn from 'classnames';
import isEqual from 'lodash/isEqual';
import { FixedSizeList } from 'react-window';
import { TypeaheadInfo } from '../TypeaheadInfo';
import { TypeaheadItem } from '../TypeaheadItem';
import { flattenGroupItems, calculateLongestLabel, calculateListSizes } from '../utils';
import { CompletionItemKind, GrafanaThemeType } from '../types';
import { Portal } from '../Portal';
import '../styles/typeahead.css';
import { ThemeContext } from '../context';

var modulo = function modulo(a, n) {
  return a - n * Math.floor(a / n);
};

export var Typeahead = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Typeahead, _React$PureComponent);

  var _super = _createSuper(Typeahead);

  function Typeahead() {
    var _this;

    _classCallCheck(this, Typeahead);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.listRef = /*#__PURE__*/createRef();
    _this.state = {
      hoveredItem: null,
      typeaheadIndex: null,
      allItems: [],
      listWidth: -1,
      listHeight: -1
    };

    _this.componentDidMount = function () {
      if (_this.props.menuRef) {
        _this.props.menuRef(_assertThisInitialized(_this));
      }

      document.addEventListener('selectionchange', _this.handleSelectionChange);
      var allItems = flattenGroupItems(_this.props.groupedItems);
      var longestLabel = calculateLongestLabel(allItems);

      var _calculateListSizes = calculateListSizes(longestLabel, allItems),
          listHeight = _calculateListSizes.listHeight,
          listWidth = _calculateListSizes.listWidth;

      _this.setState({
        allItems: allItems,
        listHeight: listHeight,
        listWidth: listWidth
      });
    };

    _this.componentWillUnmount = function () {
      document.removeEventListener('selectionchange', _this.handleSelectionChange);
    };

    _this.handleSelectionChange = function () {
      _this.forceUpdate();
    };

    _this.componentDidUpdate = function (prevProps, prevState) {
      if (_this.state.typeaheadIndex !== null && prevState.typeaheadIndex !== _this.state.typeaheadIndex && _this.listRef && _this.listRef.current) {
        if (_this.state.typeaheadIndex === 1) {
          _this.listRef.current.scrollToItem(0); // special case for handling the first group label


          return;
        }

        _this.listRef.current.scrollToItem(_this.state.typeaheadIndex);
      }

      if (isEqual(prevProps.groupedItems, _this.props.groupedItems) === false) {
        var allItems = flattenGroupItems(_this.props.groupedItems);
        var longestLabel = calculateLongestLabel(allItems);

        var _calculateListSizes2 = calculateListSizes(longestLabel, allItems),
            listHeight = _calculateListSizes2.listHeight,
            listWidth = _calculateListSizes2.listWidth;

        _this.setState({
          allItems: allItems,
          typeaheadIndex: null,
          listHeight: listHeight,
          listWidth: listWidth
        });
      }
    };

    _this.onMouseEnter = function (index) {
      _this.setState({
        hoveredItem: index
      });
    };

    _this.onMouseLeave = function () {
      _this.setState({
        hoveredItem: null
      });
    };

    _this.moveMenuIndex = function (moveAmount) {
      var itemCount = _this.state.allItems.length;

      if (itemCount) {
        // Select next suggestion
        var typeaheadIndex = _this.state.typeaheadIndex || 0;
        var newTypeaheadIndex = modulo(typeaheadIndex + moveAmount, itemCount);

        if (_this.state.allItems[newTypeaheadIndex].kind === CompletionItemKind.GroupTitle) {
          newTypeaheadIndex = modulo(newTypeaheadIndex + moveAmount, itemCount);
        }

        _this.setState({
          typeaheadIndex: newTypeaheadIndex
        });

        return;
      }
    };

    _this.insertSuggestion = function () {
      if (_this.props.onSelectSuggestion && _this.state.typeaheadIndex !== null) {
        _this.props.onSelectSuggestion(_this.state.allItems[_this.state.typeaheadIndex]);
      }
    };

    return _this;
  }

  _createClass(Typeahead, [{
    key: "menuPosition",
    get: function get() {
      // Exit for unit tests
      if (!window.getSelection) {
        return '';
      }

      var selection = window.getSelection();
      var node = selection && selection.anchorNode; // Align menu overlay to editor node

      if (node && node.parentElement) {
        // Read from DOM
        var rect = node.parentElement.getBoundingClientRect();
        var _window = window,
            scrollX = _window.scrollX;
        var _window2 = window,
            scrollY = _window2.scrollY;
        return "position: absolute; display: flex; top: ".concat(rect.top + scrollY + rect.height + 6, "px; left: ").concat(rect.left + scrollX - 2, "px");
      }

      return '';
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          prefix = _this$props.prefix,
          _this$props$isOpen = _this$props.isOpen,
          isOpen = _this$props$isOpen === void 0 ? false : _this$props$isOpen,
          origin = _this$props.origin;
      var _this$state = this.state,
          allItems = _this$state.allItems,
          hoveredItem = _this$state.hoveredItem,
          typeaheadIndex = _this$state.typeaheadIndex,
          listHeight = _this$state.listHeight,
          listWidth = _this$state.listWidth;
      var showDocumentation = hoveredItem || typeaheadIndex;
      var documentationItem = allItems[hoveredItem ? hoveredItem : typeaheadIndex || 0];
      return /*#__PURE__*/React.createElement(Portal, {
        origin: origin,
        isOpen: isOpen,
        style: this.menuPosition
      }, /*#__PURE__*/React.createElement("ul", {
        className: cn('qf__typeahead', {
          'qf-light__typeahead': this.context.type === GrafanaThemeType.Light,
          'qf-dark__typeahead': this.context.type === GrafanaThemeType.Dark
        })
      }, /*#__PURE__*/React.createElement(FixedSizeList, {
        ref: this.listRef,
        itemCount: allItems.length,
        itemSize: 34,
        itemKey: function itemKey(index) {
          var item = allItems && allItems[index];
          var key = item ? "".concat(index, "-").concat(item.label) : "".concat(index);
          return key;
        },
        width: listWidth,
        height: listHeight
      }, function (_ref) {
        var index = _ref.index,
            style = _ref.style;
        var item = allItems && allItems[index];

        if (!item) {
          return null;
        }

        return /*#__PURE__*/React.createElement(TypeaheadItem, {
          onClickItem: function onClickItem() {
            return _this2.props.onSelectSuggestion ? _this2.props.onSelectSuggestion(item) : {};
          },
          isSelected: typeaheadIndex === null ? false : allItems[typeaheadIndex] === item,
          item: item,
          prefix: prefix,
          style: style,
          onMouseEnter: function onMouseEnter() {
            return _this2.onMouseEnter(index);
          },
          onMouseLeave: _this2.onMouseLeave
        });
      })), showDocumentation && /*#__PURE__*/React.createElement(TypeaheadInfo, {
        height: 310,
        item: documentationItem
      }));
    }
  }]);

  return Typeahead;
}(React.PureComponent);
Typeahead.contextType = ThemeContext;