import React, { useContext } from 'react';
import cn from 'classnames';
import { GrafanaThemeType } from '../types';
import { ThemeContext } from '../context';
import '../styles/typeaheadInfo.css';
export var TypeaheadInfo = function TypeaheadInfo(_ref) {
  var item = _ref.item,
      height = _ref.height;
  var visible = item && !!item.documentation;
  var label = item ? item.label : '';
  var theme = useContext(ThemeContext);
  return /*#__PURE__*/React.createElement("div", {
    className: cn('qf__type-ahead-info', {
      'qf-visible__type-ahead-info': visible,
      'qf-hidden__type-ahead-info': !visible,
      'qf-light__type-ahead-info': theme.type === GrafanaThemeType.Light,
      'qf-dark__type-ahead-info': theme.type === GrafanaThemeType.Dark
    })
  }, /*#__PURE__*/React.createElement("b", null, label), /*#__PURE__*/React.createElement("hr", null), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("p", null, item === null || item === void 0 ? void 0 : item.documentation)));
};