import React, { useContext } from 'react';
import cn from 'classnames'; // @ts-ignore

import Highlighter from 'react-highlight-words';
import { ThemeContext } from '../context';
import { CompletionItemKind, GrafanaThemeType } from '../types';
import '../styles/typeaheadItem.css';
export var TypeaheadItem = function TypeaheadItem(props) {
  var theme = useContext(ThemeContext);
  var isSelected = props.isSelected,
      item = props.item,
      prefix = props.prefix,
      style = props.style,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      onClickItem = props.onClickItem;
  var label = item.label || '';

  if (item.kind === CompletionItemKind.GroupTitle) {
    return /*#__PURE__*/React.createElement("li", {
      className: "qf__type-ahead-item-group-title",
      style: style
    }, /*#__PURE__*/React.createElement("span", null, label));
  }

  return /*#__PURE__*/React.createElement("li", {
    className: cn('qf__type-ahead-item', {
      'qf-light__type-ahead-item-selected': theme.type === GrafanaThemeType.Light && isSelected,
      'qf-dark__type-ahead-item-selected': theme.type === GrafanaThemeType.Dark && isSelected
    }),
    style: style,
    onMouseDown: onClickItem,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/React.createElement(Highlighter, {
    textToHighlight: label,
    searchWords: [prefix || ''],
    highlightClassName: "qf__type-ahead-item-match"
  }));
};