function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var getCopiedText = function getCopiedText(textBlocks, startOffset, endOffset) {
  if (!textBlocks.length) {
    return undefined;
  }

  var excludingLastLineLength = textBlocks.slice(0, -1).join('').length + textBlocks.length - 1;
  return textBlocks.join('\n').slice(startOffset, excludingLastLineLength + endOffset);
};

export function ClipboardPlugin() {
  var clipboardPlugin = {
    onCopy: function onCopy(event, editor, next) {
      var clipEvent = event;
      clipEvent.preventDefault();
      var _editor$value = editor.value,
          document = _editor$value.document,
          selection = _editor$value.selection;
      var startOffset = selection.start.offset,
          endOffset = selection.end.offset;
      var selectedBlocks = document.getLeafBlocksAtRange(selection).toArray().map(function (block) {
        return block.text;
      });
      var copiedText = getCopiedText(selectedBlocks, startOffset, endOffset);

      if (copiedText && clipEvent.clipboardData) {
        clipEvent.clipboardData.setData('Text', copiedText);
      }

      return true;
    },
    onPaste: function onPaste(event, editor, next) {
      var clipEvent = event;
      clipEvent.preventDefault();

      if (clipEvent.clipboardData) {
        var pastedValue = clipEvent.clipboardData.getData('Text');
        var lines = pastedValue.split('\n');

        if (lines.length) {
          editor.insertText(lines[0]);

          var _iterator = _createForOfIteratorHelper(lines.slice(1)),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var line = _step.value;
              editor.splitBlock().insertText(line);
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
      }

      return true;
    }
  };
  return _objectSpread(_objectSpread({}, clipboardPlugin), {}, {
    onCut: function onCut(event, editor, next) {
      var clipEvent = event;
      clipboardPlugin.onCopy(clipEvent, editor, next);
      editor.deleteAtRange(editor.value.selection);
      return true;
    }
  });
}