function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { Range as SlateRange } from 'slate';
import { isKeyHotkey } from 'is-hotkey';
var isIndentLeftHotkey = isKeyHotkey('mod+[');
var isShiftTabHotkey = isKeyHotkey('shift+tab');
var isIndentRightHotkey = isKeyHotkey('mod+]');
var SLATE_TAB = '  ';

var handleTabKey = function handleTabKey(event, editor, next) {
  var _editor$value = editor.value,
      startBlock = _editor$value.startBlock,
      endBlock = _editor$value.endBlock,
      _editor$value$selecti = _editor$value.selection,
      _editor$value$selecti2 = _editor$value$selecti.start,
      startOffset = _editor$value$selecti2.offset,
      startKey = _editor$value$selecti2.key,
      _editor$value$selecti3 = _editor$value$selecti.end,
      endOffset = _editor$value$selecti3.offset,
      endKey = _editor$value$selecti3.key;
  var first = startBlock.getFirstText();
  var startBlockIsSelected = first && startOffset === 0 && startKey === first.key && endOffset === first.text.length && endKey === first.key;

  if (startBlockIsSelected || !startBlock.equals(endBlock)) {
    handleIndent(editor, 'right');
  } else {
    editor.insertText(SLATE_TAB);
  }
};

var handleIndent = function handleIndent(editor, indentDirection) {
  var curSelection = editor.value.selection;
  var selectedBlocks = editor.value.document.getLeafBlocksAtRange(curSelection).toArray();

  if (indentDirection === 'left') {
    var _iterator = _createForOfIteratorHelper(selectedBlocks),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var block = _step.value;
        var blockWhitespace = block.text.length - block.text.trimLeft().length;
        var textKey = block.getFirstText().key;
        var rangeProperties = {
          anchor: {
            key: textKey,
            offset: blockWhitespace,
            path: []
          },
          focus: {
            key: textKey,
            offset: blockWhitespace,
            path: []
          }
        };
        editor.deleteBackwardAtRange(SlateRange.create(rangeProperties), Math.min(SLATE_TAB.length, blockWhitespace));
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  } else {
    var startText = editor.value.startText;
    var textBeforeCaret = startText.text.slice(0, curSelection.start.offset);
    var isWhiteSpace = /^\s*$/.test(textBeforeCaret);

    var _iterator2 = _createForOfIteratorHelper(selectedBlocks),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _block = _step2.value;
        editor.insertTextByKey(_block.getFirstText().key, 0, SLATE_TAB);
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    if (isWhiteSpace) {
      editor.moveStartBackward(SLATE_TAB.length);
    }
  }
}; // Clears the rest of the line after the caret


export function IndentationPlugin() {
  return {
    onKeyDown: function onKeyDown(event, editor, next) {
      var keyEvent = event;

      if (isIndentLeftHotkey(keyEvent) || isShiftTabHotkey(keyEvent)) {
        keyEvent.preventDefault();
        handleIndent(editor, 'left');
      } else if (isIndentRightHotkey(keyEvent)) {
        keyEvent.preventDefault();
        handleIndent(editor, 'right');
      } else if (keyEvent.key === 'Tab') {
        keyEvent.preventDefault();
        handleTabKey(keyEvent, editor, next);
      } else {
        return next();
      }

      return true;
    }
  };
}