import { isKeyHotkey } from 'is-hotkey';
var isSelectLineHotkey = isKeyHotkey('mod+l'); // Clears the rest of the line after the caret

export function SelectionShortcutsPlugin() {
  return {
    onKeyDown: function onKeyDown(event, editor, next) {
      var keyEvent = event;

      if (isSelectLineHotkey(keyEvent)) {
        keyEvent.preventDefault();
        var _editor$value = editor.value,
            focusBlock = _editor$value.focusBlock,
            document = _editor$value.document;
        editor.moveAnchorToStartOfBlock();
        var nextBlock = document.getNextBlock(focusBlock.key);

        if (nextBlock) {
          editor.moveFocusToStartOfNextBlock();
        } else {
          editor.moveFocusToEndOfText();
        }
      } else {
        return next();
      }

      return true;
    }
  };
}