import { CompletionItemKind } from '../types';
export var flattenGroupItems = function flattenGroupItems(groupedItems) {
  var completionItems = groupedItems.reduce(function (all, _ref) {
    var items = _ref.items,
        label = _ref.label;
    all.push({
      label: label,
      kind: CompletionItemKind.GroupTitle
    });
    return items.reduce(function (all, item) {
      all.push(item);
      return all;
    }, all);
  }, []);
  return completionItems;
};
export var calculateLongestLabel = function calculateLongestLabel(allItems) {
  return allItems.reduce(function (longest, current) {
    return longest.length < current.label.length ? current.label : longest;
  }, '');
};
var maxListWidth = 800;
var minListWidth = 200;
export var calculateListSizes = function calculateListSizes(longestLabel, allItems) {
  var listWidth = longestLabel.length * 8 + 24;
  listWidth = listWidth > maxListWidth ? maxListWidth : listWidth;
  listWidth = listWidth < minListWidth ? minListWidth : listWidth;
  var listHeight = allItems.length * 34;
  listHeight = listHeight > 340 ? 340 : listHeight;
  listHeight = listHeight < 100 ? 100 : listHeight;
  return {
    listHeight: listHeight,
    listWidth: listWidth
  };
};